// --- [ rs232.c ] ------------------------------------------------------------

#include <avr/io.h>
#include <avr/pgmspace.h> 
#include <avr/interrupt.h> 
#include "rs232.h"
#include "vnc.h"

//uint8_t tx_buffer[TX_BUFFER];
//uint8_t tx_tail, tx_head;

// ----------------------------------------------------------------------------
// Setzt die Baudrate
// der bergebene Parameter entspricht dem Wert von UBBRL

void rs232_init(uint8_t baud)
{
UBRRL = baud;	
//UBRRH = 0;
UCSRB = (1<<RXCIE | 1<<TXEN | 1<<RXEN);
UCSRC = (1<<URSEL | 0<<UMSEL) | (1<<UCSZ1) | (1<<UCSZ0);
// URSEL - Achtung bei ATmega 8
//UCSRC |= (0<<UMSEL) | (1<<UCSZ1) | (1<<UCSZ0);
}

/*
// ---------------------------------------------------------------------------
// Baudrate fr die hhere Geschwindigkeit setzen
void rs232_init_38400(void)
{
UBRRL = TEILER_38400;	
//UBRRH = 0;
UCSRB = (1<<RXCIE | 1<<TXEN | 1<<RXEN);
UCSRC = (1<<URSEL | 0<<UMSEL) | (1<<UCSZ1) | (1<<UCSZ0);
// URSEL - Achtung bei ATmega 8
} */


// ----------------------------------------------------------------------------
// ein einzelnes Zeichen auf COM ausgeben
void put_c(uint8_t Zeichen)
{
while(!(UCSRA & (1<<UDRE)));
UDR = Zeichen;
}

// ----------------------------------------------------------------------------
// einen String auf COM ausgeben
void put_s(char *s)
{
while(*s)
	{
	put_c(*s);
	s++;
	}
}

// ----------------------------------------------------------------------------
// wenn auf Antworten des VNC gewartet wird, dann wird auf pollen umgeschaltet
// Sendet der VNC von sich aus Meldungen, dann werden die mittels der ISR
// im VNC_rx_buffer abgelegt.
// das Ende der Meldung wird am CHR_RETURN erkannt (es werden keine binren Daten versandt!)
ISR(USART_RXC_vect)
{
register uint8_t i;
i = UDR;

//isr_buffer[i] = UDR;
if (i == CHR_RETURN)	isr_flag = TRUE;

//i++;
//i &= (ISR_BUFFER_SIZE - 1);
//isr_index = i;

}

/*
// ----------------------------------------------------------------------------
// gibt einen String aus dem Flash aus
void puts_p(const char *progmem_s)
{
register char c;
while ( (c = pgm_read_byte(progmem_s++)) )
	{
   put_c(c);
	}
}


// ----------------------------------------------------------------------------
// Prfen, ob Platz im Sendepuffer ist
// Ist der Fall, wenn (rx_head + 1) ungleich rx_tail ist
uint8_t tx_buffer_free(void)
{
return(!(((tx_head + 1) & TX_BUFFER_MASK) == tx_tail));
}

// ----------------------------------------------------------------------------
// ein Byte im Sendepuffer ablegen, nachdem geprft wurde, ob Platz vorhanden
void tx_buffer_put_c(uint8_t c)
{
tx_buffer[tx_head] = c;
tx_head++;
tx_head &= TX_BUFFER_MASK;
//tx_head = tx_head & TX_BUFFER_MASK;
}

// ----------------------------------------------------------------------------
// Prfen, ob ein Byte zum Senden im rx_buffer vorhanden ist
// ist der Fall, wenn rx_tail ungleich rx_head
uint8_t byte_in_tx_buffer(void)
{
return (!(tx_tail == tx_head));
}

// ----------------------------------------------------------------------------
// ein Byte senden (nachdem geprft worden ist, das Daten vorhanden sind)
void send_byte_from_tx_buffer(void)
{
put_c(tx_buffer[tx_tail]);
tx_tail++;
tx_tail &= TX_BUFFER_MASK;
//tx_tail = tx_tail & TX_BUFFER_MASK;
}


// ----------------------------------------------------------------------------
// wandelt Byte in Hexdarstellung um und gibt Hex auf COM aus
void print_hexbyte(unsigned char i)
{
unsigned char h;
    
h = i & 0xF0;              	// High nibble
h = h>>4;
h = h + '0';
    
if (h > '9') h += 7;

i &= 0x0F;         				// Low nibble
i +='0';
if (i > '9') i += 7;

put_c('0');
put_c('x');
put_c(h);
put_c(i);
put_c(' ');
}

*/
// --- [ eof ] ----------------------------------------------------------------