// --- [ vnc.h ] --------------------------------------------------------------
//
// tab = 3
// ----------------------------------------------------------------------------

#ifndef EXTERN
#define EXTERN extern
#endif

#define  VNC_BAUD_RATE			19200  			// 9600, 19200 [,38400, 57600, 115200]

#define  RX_BUFFER_SIZE			768				// Gre des Empfangspuffers
#define  BLOCK_SIZE				RX_BUFFER_SIZE	// Blockgre beim Kopieren von Dateien

#define  TX_BUFFER_SIZE			8					// Sendepuffer (wird nicht benutzt)

// --- globale Variablen ------------------------------------------------------
EXTERN volatile uint8_t VNC_timeout;			// Zhler fr Warteschleifen (33 ms Takt)
EXTERN volatile uint8_t isr_flag;				// signalisert den Empfang von RS232
EXTERN uint8_t  tx_buffer[TX_BUFFER_SIZE];
EXTERN uint8_t  rx_buffer[RX_BUFFER_SIZE];	// Empfangs- und ggf. Sendepuffer
EXTERN uint8_t time[6];								// Datum und Uhrzeit
EXTERN union filesize {uint16_t word[2]; uint8_t byte[4];} VNC_fs;

// von extern zugreifbare Funktionen
void VNC_init(void);
void VNC_exit(void);
void VNC_md(void);
void VNC_rd(void);
void VNC_cd(uint8_t);
void VNC_file_access(uint8_t modus);
void VNC_write_data(uint16_t cnt, uint8_t *buffer);
void VNC_read_data(uint16_t cnt);
void VNC_get_filesize(void);
void VNC_set_filename(char *file);
void VNC_make_name(uint8_t, uint8_t);
void VNC_suspend(void);
void VNC_wake_up(void);
void VNC_insert_disk(void);
void VNC_remove_disk(void);
void VNC_send_cmd(uint8_t);
void VNC_copy_file(uint8_t, uint8_t);
void VNC_seek(uint16_t pos);
uint8_t VNC_get_error(void);
															// VNC  Instructions
#define	VNC_SCS						0x10			// Konfiguration Short Command Set
#define	VNC_ECS						0x11			// Extended Command Set (default)
#define	VNC_IPA						0x90			// Monitor Mode ASCI
#define	VNC_IPH						0x91			// Monitor Mode Hex (default)

#define	VNC_SBD						0x14			// Set_Baud_Rate

#define	VNC_SUD						0x15			// Suspend disk
#define	VNC_WKD						0x16			// wake disk

#define	VNC_DIR						0x01			// DIR
#define	VNC_DLD						0x05			// Delete Directory
#define	VNC_MKD						0x06			// Make Directory
#define	VNC_CD						0x02			// Change Directory

#define	VNC_RD						0x04			// Read file (hole file)
#define	VNC_RDF						0x0B			// Read file (dword Bytes)
#define	VNC_DLF						0x07			// Delete File
#define	VNC_WRF						0x08			// write file
#define	VNC_OPW						0x09			// Open for write
#define	VNC_OPR						0x0E			// Open for read
#define	VNC_CLF						0x0A			// Close file
#define	VNC_REN						0x0C			// Rename file
#define	VNC_FS						0x12			// Free space (4 Byte)
#define	VNC_FSE						0x93			// Free Space (6 Byte)
#define	VNC_SEK						0x28			// Seek offset position
#define  VNC_EMPTY_CMD				0x00

#define	VNC_NO_ERR					0				// Erfolg oder Fehlercodes ...
#define	VNC_ERR_FI					1				// File invalid
#define	VNC_ERR_F0					2				// File open
#define	VNC_ERR_RO					4				// Read only
#define	VNC_ERR_CF					8				// Command Failed
#define	VNC_ERR_ND					16				// No Disk

#define	VNC_ERR_DF					32				// Disk full
#define	VNC_ERR_BC					128 + 32		// Bad Command
#define	VNC_ERR_NE					128 + 64		// Dir not empty
#define	VNC_ERR_TO					128 + 64 + 32// Timeout
#define	VNC_ERR						64 + 32		// sollte nicht auftreten

#define	VNC_PROMPT_WAIT			10				// Zhler fr Timeout, wird von TIM0_ISR runtergezhlt
															// 
#define	FILE_READ					VNC_OPR		// Parameter der Funktion VNC_file_access(modus)
#define	FILE_WRITE					VNC_OPW
#define	FILE_CLOSE					VNC_CLF
#define	FILE_DELETE					VNC_DLF

#define	CHR_SYNCH					'E'			// Synch
#define	CHR_SPACE					0x20			// Leerzeichen
#define	CHR_RETURN					0x0D			// CR
#define	CHR_PROMPT					'>'			// Prompt

#define	TRUE							1
#define	FALSE							0
#define  FILE							0				// mit VNC_make_name() einen Filenamen generieren
#define  DIR							1				// mit VNC_make_name() einen Verzeichnisnamen generieren
#define  UP								1				// mit cd in bergeordnetes Verzeichnis wechseln
#define  DOWN							0				// mit cd in untergeordnetets Verzeichnis 'VNC_dirname' wechseln

#define  LEDPORT						PORTD
// PD0, PD1 -> TxD, RxD
#define  LED_READY					PD2			// Stick ist vorhanden (Blinken: Stick nicht vorhanden)
#define  LED_WAIT						PD3			// Stich darf entfernt werden
// PD4 .. 7 -> Fehlercodes

// --- [ eof ] ----------------------------------------------------------------
